<?php
/** 
 *	ショートコード: Short code
 */
class olbShortcode {
	/** 
	 *	[ショートコード]日別スケジュール: [Short code]Dayly schedule board
	 */
	public static function showDailySchedule($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
				),
				$atts
			)
		);

		ob_start();
		$rooms = new olbRoom($olb->room_per_page);
		$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">%PREV_PAGE%</div>
<div id="list_datenavi" class="list_datenavi">
%PREV_DATE%
%CURRENT_DATE%
%NEXT_DATE%
</div>
<div id="next_page" class="next_page">%NEXT_PAGE%</div>
</div>
EOD;
		$search = array(
				'%PREV_PAGE%',
				'%PREV_DATE%',
				'%CURRENT_DATE%',
				'%NEXT_DATE%',
				'%NEXT_PAGE%',
			);
		$text_prev = __('&laquo; PREV', OLBsystem::TEXTDOMAIN);
		$text_next = __('NEXT &raquo;', OLBsystem::TEXTDOMAIN);
		$text_prevday = __('&laquo; PREV DAY', OLBsystem::TEXTDOMAIN);
		$text_nextday = __('NEXT DAY &raquo;', OLBsystem::TEXTDOMAIN);
		$replace = array(
				$rooms->getPrevPageLink(-1, $text_prev, $_SERVER['QUERY_STRING']),
				$rooms->getPrevDateLink($olb->startdate, -1, $text_prevday, $_SERVER['QUERY_STRING']),
				$olb->startdate,
				$rooms->getNextDateLink($olb->startdate, 1, $text_nextday, $_SERVER['QUERY_STRING']),
				$rooms->getNextPageLink( 1, $text_next, $_SERVER['QUERY_STRING']),
			);
		echo str_replace($search, $replace, $format);
		echo $olb->htmlDailySchedule($rooms->getList(), $olb->startdate);
		echo str_replace($search, $replace, $format);

		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}


	/** 
	 *	[ショートコード]週間スケジュール: [Short code]Weekly schedule board
	 */
	public static function showWeeklySchedule($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'id' => null,
				),
				$atts
			)
		);

		ob_start();
		$olb->room_id = $id;
		$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">&nbsp;</div>
<div id="list_datenavi" class="list_datenavi">
%PREV_DATE%
%CURRENT_DATE%
%NEXT_DATE%
</div>
<div id="next_page" class="next_page">&nbsp;</div>
</div>
EOD;
		$search = array(
				'%PREV_DATE%',
				'%CURRENT_DATE%',
				'%NEXT_DATE%',
			);
		$text_prevweek = __('&laquo; PREV WEEK', OLBsystem::TEXTDOMAIN);
		$text_nextweek = __('NEXT WEEK &raquo;', OLBsystem::TEXTDOMAIN);
		$replace = array(
				olbPaging::getPrevDateLink($olb->startdate, -7, $text_prevweek, $_SERVER['QUERY_STRING']),
				$olb->startdate,
				olbPaging::getNextDateLink($olb->startdate,  7, $text_nextweek, $_SERVER['QUERY_STRING']),
			);
		echo str_replace($search, $replace, $format);
		echo $olb->htmlWeeklySchedule();
		echo str_replace($search, $replace, $format);

		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]スケジュール設定: [Short code]Edit schedule board (for room manager)
	 */
	public static function showEditSchedule($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isAdmin() && !isset($olb->qs['room_id'])){
			$error = 'CHOOSE_TEACHER';
			echo olbFunction::errorMessage($error);
			//echo '<p>講師が指定されていません。</p>';
			$rooms = olbRoom::getAll();
			if(!empty($rooms)){
				echo '<p>'.__('Select teacher', OLBsystem::TEXTDOMAIN).'</p>';
				//echo "<p>スケジュールを編集する講師をクリックします</p>\n";
				echo "<ul>\n";
				$url = get_permalink(get_page_by_path($olb->edit_schedule_page)->ID);
				foreach($rooms as $r){
					if(strstr($url, '?')) {
						$query_string = sprintf('&room_id=%d', $r['id']);
					}
					else {
						$query_string = sprintf('&room_id=%d', $r['id']);
					}
					printf('<li><a href="%s%s">%s</a></li>'."\n", $url, $query_string, $r['name']);
				}
				echo "</ul>\n";
			}
			else {
				$error = 'NO_TEACHERS';
				echo olbFunction::errorMessage($error);
				//echo '<p>現在、講師は登録されていません</p>';
			}
		}
		else if($olb->operator->isLoggedIn() && ($olb->operator->isRoomManager() || $olb->operator->isAdmin())) {
			$room = olbRoom::get($olb->room_id);
			if(empty($room['id'])){
				$error = 'NONEXISTENT_TEACHER';
				echo olbFunction::errorMessage($error);
				//echo '<p>指定された講師は存在しません</p>';
			}
			else {
				printf('<h3>%s</h3>'."\n", $room['name']);
				if($olb->operator->isAdmin()){
					$format = __('%s edites schedule of %s', OLBsystem::TEXTDOMAIN);
					printf('<p>'.$format.'<p>'."\n", $olb->operator->data['name'], $room['name']);
					//printf('<p>%sさんが%sさんのスケジュールを編集しています<p>'."\n", $admin->data['name'], $user->data['name']);
				}
				$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">&nbsp;</div>
<div id="list_datenavi" class="list_datenavi">
%PREV_DATE%
%CURRENT_DATE%
%NEXT_DATE%
</div>
<div id="next_page" class="next_page">&nbsp;</div>
</div>
EOD;
				$search = array(
						'%PREV_DATE%',
						'%CURRENT_DATE%',
						'%NEXT_DATE%',
					);
				$text_prevweek = __('&laquo; PREV WEEK', OLBsystem::TEXTDOMAIN);
				$text_nextweek = __('NEXT WEEK &raquo;', OLBsystem::TEXTDOMAIN);
				$replace = array(
						olbPaging::getPrevDateLink($olb->startdate, -7, $text_prevweek, $_SERVER['QUERY_STRING']),
						$olb->startdate,
						olbPaging::getNextDateLink($olb->startdate,  7, $text_nextweek, $_SERVER['QUERY_STRING']),
					);
				echo str_replace($search, $replace, $format);
				echo $olb->htmlEditSchedule();
				echo str_replace($search, $replace, $format);
			}
		}
		else {
			echo __('Do not have authority to show this page.', OLBsystem::TEXTDOMAIN);
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]予約フォーム: [Short code]Reserve form
	 */
	public static function showReserveForm($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'position' => 'before',
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isMember()){
			if($position == 'before') {
				echo $content;
			}
			echo olbTimetable::htmlReserveForm();
			if($position == 'after') {
				echo $content;
			}
		}
		else {
			_e('Do not have authority to show this page.', OLBsystem::TEXTDOMAIN);
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}


	/** 
	 *	[ショートコード]講師用キャンセルフォーム: [Short code]Cancel form (from Room manager) 
	 */
	public static function showCancelForm($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'position' => 'before',
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && ($olb->operator->isRoomManager() || $olb->operator->isAdmin())){
			if($position == 'before') {
				echo $content;
			}
			echo olbTimetable::htmlCancelForm();
			if($position == 'after') {
				echo $content;
			}
		}
		else {
			_e('Do not have authority to show this page.', OLBsystem::TEXTDOMAIN);
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]講師用評価フォーム: [Short code]Report form (from Room manager) 
	 */
	public static function showReportForm($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'position' => 'before',
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && ($olb->operator->isRoomManager() || $olb->operator->isAdmin())){
			if($position == 'before') {
				echo $content;
			}
			echo olbTimetable::htmlReportForm();
			if($position == 'after') {
				echo $content;
			}
		}
		else {
			_e('Do not have authority to show this page.', OLBsystem::TEXTDOMAIN);
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]会員受講履歴: [Short code ] Member's attendance history 
	 */
	public static function showMembersHistory($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'perpage' => 10,
					'pagenavi' => true,
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isMember()){
			$records = new olbHistory('history', 'user', $olb->operator->data['id'], $perpage);
			if($records->recordmax){
				if($pagenavi){
					$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">%PREV_PAGE%</div>
<div id="next_page" class="next_page">%NEXT_PAGE%</div>
</div>
EOD;
					$search = array(
							'%PREV_PAGE%',
							'%NEXT_PAGE%',
						);
					$text_prev = __('&laquo; PREV', OLBsystem::TEXTDOMAIN);
					$text_next = __('NEXT &raquo;', OLBsystem::TEXTDOMAIN);
					$replace = array(
							$records->getPrevPageLink(-1, $text_prev, $_SERVER['QUERY_STRING']),
							$records->getNextPageLink( 1, $text_next, $_SERVER['QUERY_STRING']),
						);
					echo str_replace($search, $replace, $format);
				}
				echo $records->htmlMembersHistory();
			}
			else {
				echo $content;
			}
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]会員予定表示: [Short code]Member's future schedule
	 */
	public static function showMembersSchedule($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'perpage' => 10,
					'pagenavi' => true,
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isMember()){
			$records = new olbHistory('future', 'user', $olb->operator->data['id'], $perpage);
			if($records->recordmax){
				if($pagenavi){
					$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">%PREV_PAGE%</div>
<div id="next_page" class="next_page">%NEXT_PAGE%</div>
</div>
EOD;
					$search = array(
							'%PREV_PAGE%',
							'%NEXT_PAGE%',
						);
					$text_prev = __('&laquo; PREV', OLBsystem::TEXTDOMAIN);
					$text_next = __('NEXT &raquo;', OLBsystem::TEXTDOMAIN);
					$replace = array(
							$records->getPrevPageLink(-1, $text_prev, $_SERVER['QUERY_STRING']),
							$records->getNextPageLink( 1, $text_next, $_SERVER['QUERY_STRING']),
						);
					echo str_replace($search, $replace, $format);
				}
				echo $records->htmlMembersSchedule();
			}
			else {
				echo $content;
			}
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]講師講義履歴: [Short code ] Teacher's lecuture history 
	 */
	public static function showRoomHistory($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'perpage' => 10,
					'pagenavi' => true,
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isRoomManager()){
			$records = new olbHistory('history', 'room', $olb->operator->data['id'], $perpage);
			if($records->recordmax){
				if($pagenavi){
					$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">%PREV_PAGE%</div>
<div id="next_page" class="next_page">%NEXT_PAGE%</div>
</div>
EOD;
					$search = array(
							'%PREV_PAGE%',
							'%NEXT_PAGE%',
						);
					$text_prev = __('&laquo; PREV', OLBsystem::TEXTDOMAIN);
					$text_next = __('NEXT &raquo;', OLBsystem::TEXTDOMAIN);
					$replace = array(
							$records->getPrevPageLink(-1, $text_prev, $_SERVER['QUERY_STRING']),
							$records->getNextPageLink( 1, $text_next, $_SERVER['QUERY_STRING']),
						);
					echo str_replace($search, $replace, $format);
				}
				echo $records->htmlRoomHistory();
			}
			else {
				echo $content;
			}
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]講師予定表示: [Short code] Teacher's future schedule
	 */
	public static function showRoomSchedule($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'perpage' => 10,
					'pagenavi' => true,
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isRoomManager()){
			$records = new olbHistory('future', 'room', $olb->operator->data['id'], $perpage);
			if($records->recordmax){
				if($pagenavi){
					$format = <<<EOD
<div id="list_pagenavi" class="list_pagenavi">
<div id="prev_page" class="prev_page">%PREV_PAGE%</div>
<div id="next_page" class="next_page">%NEXT_PAGE%</div>
</div>
EOD;
					$search = array(
							'%PREV_PAGE%',
							'%NEXT_PAGE%',
						);
					$text_prev = __('&laquo; PREV', OLBsystem::TEXTDOMAIN);
					$text_next = __('NEXT &raquo;', OLBsystem::TEXTDOMAIN);
					$replace = array(
							$records->getPrevPageLink(-1, $text_prev, $_SERVER['QUERY_STRING']),
							$records->getNextPageLink( 1, $text_next, $_SERVER['QUERY_STRING']),
						);
					echo str_replace($search, $replace, $format);
				}
				echo $records->htmlRoomSchedule();
			}
			else {
				echo $content;
			}
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]ログイン中ユーザー情報の表示: [Short code]Show member data
	 */
	public static function showMemberData($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'key' => null,	// key='name'
				),
				$atts
			)
		);
		if($olb->operator->isLoggedIn() && $olb->operator->isMember()){
			if(isset($olb->operator->data[$key])){
				return $olb->operator->data[$key];
			}
			if($key=='free'){
				return $olb->operator->canFreeReservation();
			}
		}
		return false;
	}

	/** 
	 *	[ショートコード]ログイン中ユーザーの有効期限切れの際の表示: [Short code]Show block at expiration
	 */
	public static function showIfExpire($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
					'not' => null,
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isMember()){
			$now = date('Y-m-d', current_time('timestamp'));
			if(isset($not)){
				if($olb->operator->isNotExpire($now)) {
					echo $content;
				}
			}
			else {
				if(!$olb->operator->isNotExpire($now)) {
					echo $content;
				}
			}
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]ログイン中会員にのみ表示: [Short code]Show block only member
	 */
	public static function showIfMember($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && $olb->operator->isMember()){
			echo $content;
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	/** 
	 *	[ショートコード]ログイン中講師にのみ表示: [Short code]Show block only room-manager
	 */
	public static function showIfManager($atts, $content = null){
		global $olb;
		extract(
			shortcode_atts(
				array(
				),
				$atts
			)
		);

		ob_start();
		if($olb->operator->isLoggedIn() && ($olb->operator->isRoomManager() || $olb->operator->isAdmin())){
			echo $content;
		}
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

}
?>